package Catalyst::Action::Serialize::JSON::Alexandria::JSONResponse;

use Moose;
use namespace::autoclean;
use Data::Dumper;

extends 'Catalyst::Action';
use JSON ();

our $VERSION = '0.91';
$VERSION = eval $VERSION;

has encoder => (
   is => 'ro',
   lazy_build => 1,
);

sub _build_encoder {
 my $self = shift;
 return JSON->new->utf8->convert_blessed;
}

sub execute {
  my $self = shift;
  my ( $controller, $c ) = @_;

  eval {

    my $stash_key = (
            $controller->{'serialize'} ?
                $controller->{'serialize'}->{'stash_key'} :
                $controller->{'stash_key'}
        ) || 'rest';
    my $output = $self->serialize( $c->stash->{$stash_key} );
    $c->response->output( $output );
  };
  if($@) { $c->log->error( "$@" ); }
  return 1;
}

sub serialize {
  my $self = shift;
  my $data = shift;
  my $encoder = $self->encoder;
  $encoder->pretty(1);
  $encoder->encode( $data );
}

__PACKAGE__->meta->make_immutable;

1;

