package Catalyst::Action::Serialize::JSON::Passthrough;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # content of the stash is a JSON string
  my $stash_key = (
          $controller->{'serialize'} ?
              $controller->{'serialize'}->{'stash_key'} :
              $controller->{'stash_key'}
      ) || 'rest';

  my $content = $c->stash->{$stash_key};

#$c->log->debug(Dumper($content));

  eval { $c->response->output( $content ); };
  if($@) { $c->log->error(__PACKAGE__ . ": $@"); }
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

