package Catalyst::Action::Serialize::XML::Alexandria;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  eval { require XML::Simple; };
  if($@) {
    $c->log->warning("Could not load XML::Serializer, refusing to serialize: $@");
    return;
  }
  my $xs = XML::Simple->new(ForceArray => 1, rootname => 'response');

  my $stash_key = (
          $controller->{'serialize'} ?
              $controller->{'serialize'}->{'stash_key'} :
              $controller->{'stash_key'}
      ) || 'rest';

  my $content = $c->stash->{$stash_key};
#  $c->log->debug(Dumper($content));

  eval {
    my $output = $xs->XMLout( { data => $content } );
    $c->response->output( $output );
  };
  if($@) {
    $c->log->error($@);
  }

  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

