package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Admin::Groups::XAdd;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#  $c->log->debug( __PACKAGE__ . '::execute()' );
#  $c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  $root->setAttribute('status', $content->{status} || 'unknown');
  if( $root->getAttribute('status') eq 'success') {
    my $group = XML::LibXML::Element->new('group');

    $group->setAttribute( 'group_id', $content->{group}->{group_id} );

    $root->addChild($group);
  }
  
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

