package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Admin::IPAddresses::XAdd;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#  $c->log->debug( __PACKAGE__ . '::execute()' );
#  $c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  $root->setAttribute('status', $content->{status} || 'unknown');
  if( $root->getAttribute('status') eq 'success') {
    my $ipaddr = XML::LibXML::Element->new('ip-address');

    $ipaddr->setAttribute( 'ip_id', $content->{ip}->{ip_id} );

    $root->addChild($ipaddr);
  }
  
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

