package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Admin::Privileges::XInfo;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';

use XML::Simple; # simple ...

sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#  $c->log->debug( __PACKAGE__ . '::execute()' );
#  $c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  $root->setAttribute('status', $content->{status} || 'unknown');

  if( $root->getAttribute('status') eq 'success') {
    my $privilege = XML::LibXML::Element->new('privilege');

    foreach my $key ( %{$content->{privilege}} ) {
      my $val = $content->{privilege}->{$key} || next;
      if( ref($val) =~ /HASH/) {
      }
      elsif( ref($val) =~ /ARRAY/) {
        # logic of structure really should't be here
        my %tbl = ( members => 'member', privileges => 'privilege' );
        my $nodes = XML::LibXML::Element->new( $key );
        foreach my $e ( @{$val} ) {
          my $node = XML::LibXML::Element->new( $tbl{$key} );
          $node->appendText( $e );
          $nodes->addChild( $node );
        }
        $privilege->addChild( $nodes);
      }
      else {
        $privilege->setAttribute( $key, $val );
      }
    }
    $root->addChild($privilege);
  }
  
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

