package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Admin::SubscriptionLevels::XList;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#$c->log->debug( __PACKAGE__ . '::execute()' );
#$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  # always success
  $root->setAttribute('status', 'success');

  my $subscription_levels = XML::LibXML::Element->new('subscription-levels');

  foreach my $sl ( @{$content->{subscription_levels}} ) {

    my $subscription_level = XML::LibXML::Element->new('subscription-level');

    foreach my $key ( sort keys %{$sl} ) {
      $subscription_level->setAttribute( $key, $sl->{$key} );
    }
    $subscription_levels->addChild($subscription_level);
  }
  $root->addChild($subscription_levels);
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

