package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Admin::Users::XInfo;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';

use XML::Simple; # simple ...

sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#  $c->log->debug( __PACKAGE__ . '::execute()' );
#  $c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  $root->setAttribute('status', $content->{status} || 'unknown');

#  my $xmls = XML::Simple->new();
#  my $out = $xmls->XMLout( $content->{user}, NoAttr => 1, RootName => 'user', SuppressEmpty => 1);
#  $c->log->debug( $out );

  if( $root->getAttribute('status') eq 'success') {
    my $user = XML::LibXML::Element->new('user');

    foreach my $key ( %{$content->{user}} ) {
      if(!$key) { next; }
      my $val = $content->{user}->{$key} || next;
      if( ref($val) =~ /HASH/) { }
      elsif( ref($val) =~ /ARRAY/) {
        # logic of structure really should't be here
        my %tbl = ( groups => 'group', privileges => 'privilege', ip_addresses => 'ip_address' );
        my $nodes = XML::LibXML::Element->new( $key );
        foreach my $e ( @{$val} ) {
          my $node = XML::LibXML::Element->new( $tbl{$key} );
          $node->appendText( $e );
          $nodes->addChild( $node );
        }
        $user->addChild( $nodes);
      }
      else {
        $user->setAttribute( $key, $val );
      }
    }
    $root->addChild($user);
  }
  
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

