package Catalyst::Action::Serialize::XML::Alexandria::XResponse::Citations;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';

use XML::Simple;

sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#$c->log->debug( __PACKAGE__ . '::execute()' );
#$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  # { status: ok
  #   time: 0.00
  #   citations => [ ]
  # }
  # always success
  $root->setAttribute('status', 'success');

#$c->log->debug( Dumper( $content ) );

  foreach my $x ( @{$content->{citations}} ) {
    # { root => ucid, ucids => [ ucids ] }
    my $cites = XML::LibXML::Element->new('citations');
    $cites->setAttribute('root', $x->{root});

    foreach my $y ( @{$x->{ucids}} ) {
      my $patcit = XML::LibXML::Element->new('ucid');
      $patcit->appendText($y);
      $cites->addChild($patcit);
    }
    $dom->documentElement()->addChild($cites);
  }

  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

