package Catalyst::Action::Serialize::XML::Alexandria::XResponse::XAttachment;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';

use XML::Simple;

sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#$c->log->debug( __PACKAGE__ . '::execute()' );
#$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

#$c->log->debug( Dumper( $content ) );

  # { status: success|error
  #   attachments => [ ]
  # }
  $root->setAttribute( 'status', $content->{status} );
  $root->setAttribute( 'time', $content->{time} )
    if $content->{time};

  my $attachments = XML::LibXML::Element->new('attachments');

  foreach my $x ( @{$content->{attachments}} ) {
    my $attachment = XML::LibXML::Element->new('attachment');
    foreach my $key ( keys %{$x} ) {
      $attachment->setAttribute( $key, $x->{$key} );
    }
    $attachments->addChild( $attachment );
  }
  $dom->documentElement()->addChild($attachments);

  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

