package Catalyst::Action::Serialize::XML::Alexandria::XResponse::XEcho;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

  #$c->log->debug( __PACKAGE__ . '::execute()' );
  #$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  # always success
  $root->setAttribute('status', 'success');

  my $params = XML::LibXML::Element->new('parameters');
  foreach my $key ( sort keys %{$content} ) {
    my $param = XML::LibXML::Element->new('param');
    $param->setAttribute( 'name', $key);
    $param->appendText( $content->{$key} );
    $params->addChild($param);
  }
  $root->addChild($params);
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

