package Catalyst::Action::Serialize::XML::Alexandria::XResponse::XLogin;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';


# sub execute {
#   my ($self, $controller, $c) = @_;
#   my $xresp = $self->SUPER::execute( @_ );
#
#  where xresp is a hash
#  { respdom => XML::LibXML::Document, respcont => response content }


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  my $xresp = $self->SUPER::execute(@_);

  #$c->log->debug( __PACKAGE__ . '::execute()' );
  #$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

  foreach my $key ( sort keys %{$content} ) {
    $root->setAttribute( $key, $content->{$key} );
  }
  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

