package Catalyst::Action::Serialize::XML::Alexandria::XResponse::XSystem;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action::Serialize::XML::Alexandria::XResponse';

use XML::Simple;

sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  # builds the container response XML
  my $xresp = $self->SUPER::execute(@_);

#$c->log->debug( __PACKAGE__ . '::execute()' );
#$c->log->debug( Dumper($xresp) );

  # we know what we are building
  my $dom = $xresp->{dom};
  my $root = $dom->documentElement();

  my $content = $xresp->{content};
  if(!$content) { # setup already
    $c->response->output( $dom->toString(1) );
    return 1;
  }

$c->log->debug( Dumper( $content ) );

  # { status: success|error
  #   attachments => [ ]
  # }
  $root->setAttribute( 'status', $content->{status} );
  $root->setAttribute( 'time', $content->{time} )
    if $content->{time};

  my $load = XML::LibXML::Element->new('load');

  my $l = $content->{load};
  foreach my $key ( keys %{$l} ) {
    $load->setAttribute( $key, $l->{$key} );
  }
  $dom->documentElement()->addChild($load);

  $c->response->output( $dom->toString(1) );
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

