package Catalyst::Action::Serialize::XML::Passthrough;

use Moose;
use namespace::autoclean;
use Data::Dumper;
extends 'Catalyst::Action';


sub execute {
  my $self = shift;
  my ($controller, $c) = @_;

  eval { require XML::LibXML; };
  if($@) {
    $c->log->warning("Could not load XML::Serializer, refusing to serialize: $@");
    return;
  }

  my $p = XML::LibXML->new();

  # content of the stash is a string of XML
  my $stash_key = (
          $controller->{'serialize'} ?
              $controller->{'serialize'}->{'stash_key'} :
              $controller->{'stash_key'}
      ) || 'rest';

  my $content = $c->stash->{$stash_key};
#$c->log->debug(Dumper($content));


  eval {
    my $dom = $p->parse_string($content);
    my $output = $dom->toString(1);
    $c->response->output( $output );
  };
  if($@) {
    $c->log->error($@);
  }
  return 1;
}

__PACKAGE__->meta->make_immutable;
1;

