#!/usr/bin/env perl

use strict;
use warnings;
use LWP::UserAgent;
use HTTP::Headers;
use Test::More;
use Data::Dumper;

use lib './t';

use TestConfig;

my ($cfg, $mech);

eval {
  $cfg = TestConfig->new();
  $mech = $cfg->mech_agent;
};

plan $@ ? ( skip_all => 'Failed to load TestConfig' ) :  ( tests => 4 );

my $res = $mech->get( 'http://localhost/echo/params?a=1&b=2&c=3' , 'Requested page');
ok( $mech->status == 200 );

my $obj = $cfg->json_encoder->decode( $res->content );

# check we got what we sent
ok( $obj->{a} == 1 );
ok( $obj->{b} == 2 );
ok( $obj->{c} == 3 );

