package TestConfig;

use Moose;
use JSON;
use Test::WWW::Mechanize::Catalyst;

has 'user' =>
  ( is => 'ro', isa => 'Str', default => 'admin' );
has 'password' =>
  ( is => 'ro', isa => 'Str', default => '@dmin' );
has 'group' =>
  ( is => 'ro', isa => 'Str', default => 'Administrators' );
has 'privilege' =>
  ( is => 'ro', isa => 'Str', default => 'Attachments' );

has 'mech_agent' =>
  ( is => 'ro', lazy_build => 1 );
sub _build_mech_agent {
  my $self = shift;

  my $mech = Test::WWW::Mechanize::Catalyst->new( catalyst_app => 'Alexandria::CDWS' );

  $mech->add_header(
    'X-User' => $self->user,
    'X-Password' => $self->password,
    'Content-Type' => 'application/json',
  );
  return $mech;
}

has 'json_encoder' =>
  ( is => 'ro', lazy_build => 1 );
sub _build_json_encoder {
  my $self = shift;
  return JSON->new->utf8->convert_blessed;
}

1;

